/*
 * IDPDADeterminizer.h
 *
 *  Created on: 16. 1. 2014
 *	  Author: Jan Vesely
 */

#ifndef IDPDA_DETERMINIZER_H_
#define IDPDA_DETERMINIZER_H_

#include <set>

#include "automaton/common/State.h"
#include "automaton/PDA/InputDrivenNPDA.h"
#include "automaton/PDA/DPDA.h"

namespace determinize {

/**
 * Class for running determinization algorithm on fsm.
 */
class IDPDADeterminizer {
public:

	/**
	 * @param nfsm nondeterministic final-state machine given for determinization
	 * Runs determinization algorithm on nondeterministic fsm given in constructor.
	 */
	static automaton::DPDA determinize(const automaton::InputDrivenNPDA& nfa);

};

} /* namespace determinize */

#endif /* IDPDA_DETERMINIZER_H_ */
