#ifndef VPADETERMINIZER_H_
#define VPADETERMINIZER_H_

#include "automaton/PDA/VisiblyPushdownNPDA.h"
#include "automaton/PDA/VisiblyPushdownDPDA.h"

namespace determinize {

/**
 * Class for running basic determinization algorithm on vpa.
 */
class VPADeterminizer {
public:
	/**
	 * Runs determinization algorithm on nondeterministic vpa given in constructor.
	 *
	 * @return deterministic visibly pushdown automaton
	 */
	static automaton::VisiblyPushdownDPDA determinize(const automaton::VisiblyPushdownNPDA& nondeterministic);

};

} /* namespace determinize */

#endif /* VPADETERMINIZER_h_ */
