/*
 * LanguagePropertiesCFG.h
 *
 *  Created on: 22. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef LANGUAGE_PROPERTIED_CFG_H_
#define LANGUAGE_PROPERTIED_CFG_H_

#include <algorithm>
#include <deque>
#include <set>

#include <exception/AlibException.h>

#include <alphabet/Symbol.h>

namespace language {

/**
 * Implements algorithms from Melichar, chapter 3.3
 */
class LanguagePropertiesCFG {
public:
	/*
	 * Melichar 3.6 - decides whether L( grammar ) = \0
	 *
	 * Severals steps implemented in method CFGTransformations::getProductiveNonTerminals();
	 * @see getProductiveNonTerminals
	 */
	template<class T>
	static bool isLanguageEmpty( const T & grammar );
};

}

#endif /* LANGUAGE_PROPERTIED_CFG_H_ */
