/*
 * Minimize.h
 *
 *  Created on: Dec 9, 2013
 *      Author: Jan Travnicek
 */

#ifndef MINIMIZE_DFA_H_
#define MINIMIZE_DFA_H_

#include <automaton/Automaton.h>
#include <automaton/FSM/DFA.h>

namespace minimize {

class MinimizeDFA : public automaton::VisitableAutomatonBase::const_visitor_type {
public:
	/**
	 * @param dfa automaton to minimize
	 */
	static automaton::Automaton minimize(const automaton::Automaton& dfa);

	static automaton::DFA minimize(const automaton::DFA& dfa);

protected:
	void Visit(void*, const automaton::UnknownAutomaton& automaton) const;
	void Visit(void*, const automaton::EpsilonNFA& automaton) const;
	void Visit(void*, const automaton::NFA& automaton) const;
	void Visit(void*, const automaton::DFA& automaton) const;
	void Visit(void*, const automaton::ExtendedNFA& automaton) const;
	void Visit(void*, const automaton::CompactNFA& automaton) const;
	void Visit(void*, const automaton::DPDA& automaton) const;
	void Visit(void*, const automaton::SinglePopDPDA& automaton) const;
	void Visit(void*, const automaton::InputDrivenNPDA& automaton) const;
	void Visit(void*, const automaton::VisiblyPushdownDPDA& automaton) const;
	void Visit(void*, const automaton::VisiblyPushdownNPDA& automaton) const;
	void Visit(void*, const automaton::RealTimeHeightDeterministicDPDA& automaton) const;
	void Visit(void*, const automaton::RealTimeHeightDeterministicNPDA& automaton) const;
	void Visit(void*, const automaton::NPDA& automaton) const;
	void Visit(void*, const automaton::SinglePopNPDA& automaton) const;
	void Visit(void*, const automaton::OneTapeDTM& automaton) const;

	static const MinimizeDFA MINIMIZE_DFA;
};

}

#endif /* MINIMIZE_DFA_H_ */
