/*
 * BlankSymbol.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "BlankSymbol.h"

namespace alphabet {

BlankSymbol::BlankSymbol() {

}

SymbolBase* BlankSymbol::clone() const {
	return new BlankSymbol(*this);
}

SymbolBase* BlankSymbol::plunder() && {
	return new BlankSymbol(std::move(*this));
}

bool BlankSymbol::operator <(const ObjectBase& other) const {
	return other > *this;
}

bool BlankSymbol::operator ==(const ObjectBase& other) const {
	return other == *this;
}

bool BlankSymbol::operator >(const ObjectBase& other) const {
	return other < *this;
}

bool BlankSymbol::operator ==(const BlankSymbol&) const {
	return true;
}

bool BlankSymbol::operator <(const BlankSymbol&) const {
	return false;
}

void BlankSymbol::operator>>(std::ostream& out) const {
	out << "(Blank symbol)";
}

BlankSymbol::operator std::string () const {
	return "B";
}

BlankSymbol BlankSymbol::BLANK = BlankSymbol();

} /* namespace alphabet */
