/*
 * EndSymbol.cpp
 *
 *  Created on: Jun 19, 2014
 *      Author: Jan Travnicek
 */

#include "EndSymbol.h"

namespace alphabet {

EndSymbol::EndSymbol() {

}

SymbolBase* EndSymbol::clone() const {
	return new EndSymbol(*this);
}

SymbolBase* EndSymbol::plunder() && {
	return new EndSymbol(std::move(*this));
}

bool EndSymbol::operator <(const ObjectBase& other) const {
	return other > *this;
}

bool EndSymbol::operator ==(const ObjectBase& other) const {
	return other == *this;
}

bool EndSymbol::operator >(const ObjectBase& other) const {
	return other < *this;
}

bool EndSymbol::operator ==(const EndSymbol&) const {
	return true;
}

bool EndSymbol::operator <(const EndSymbol&) const {
	return false;
}

void EndSymbol::operator>>(std::ostream& out) const {
	out << "(EndSymbol)";
}

EndSymbol::operator std::string () const {
	return "$";
}

EndSymbol EndSymbol::END = EndSymbol();

} /* namespace alphabet */
