/*
 * SymbolFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef SYMBOL_FROM_STRING_LEXER_H_
#define SYMBOL_FROM_STRING_LEXER_H_

#include <string>
#include <sstream>

namespace alphabet {

class SymbolFromStringLexer {
public:
	enum class TokenType {
		BLANK,
		BOTTOM,
		END,
		TEOF,
		ERROR,
	};

	struct Token {
	      TokenType type;
	      std::string value;
	};
private:
	std::istream& m_In;
	Token m_Current;
public:

	SymbolFromStringLexer(std::istream&);
	SymbolFromStringLexer& next();
	Token token();
};

} /* namespace alphabet */

#endif /* SYMBOL_FROM_STRING_LEXER_H_ */
