/*
 * AutomatonBase.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef AUTOMATON_BASE_H_
#define AUTOMATON_BASE_H_

#include "../common/base.hpp"
#include "../object/ObjectBase.h"

namespace automaton {

typedef std::acceptor_base<
			automaton::UnknownAutomaton, automaton::DFA, automaton::NFA, automaton::EpsilonNFA, automaton::CompactNFA, automaton::ExtendedNFA, automaton::DPDA, automaton::SinglePopDPDA, automaton::InputDrivenNPDA, automaton::VisiblyPushdownDPDA, automaton::VisiblyPushdownNPDA, automaton::RealTimeHeightDeterministicDPDA, automaton::RealTimeHeightDeterministicNPDA, automaton::NPDA, automaton::SinglePopNPDA, automaton::OneTapeDTM
	> VisitableAutomatonBase;

/**
 * Abstract base class for all automata.
 */
class AutomatonBase : public alib::ObjectBase, public VisitableAutomatonBase {
public:
	using VisitableAutomatonBase::Accept;
	using alib::VisitableObjectBase::Accept;

	virtual AutomatonBase* clone() const = 0;
	virtual AutomatonBase* plunder() && = 0;

};

} /* namespace automaton */

#endif /* AUTOMATON_BASE_H_ */

