/*
 * BottomOfTheStackSymbolPushdownStoreAlphabet.cpp
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "BottomOfTheStackSymbolPushdownStoreAlphabet.h"
#include "../AutomatonException.h"
#include <algorithm>

namespace automaton {

BottomOfTheStackSymbolPushdownStoreAlphabet::BottomOfTheStackSymbolPushdownStoreAlphabet(const alphabet::Symbol& bottomOfTheStackSymbol) : bottomOfTheStackSymbol(bottomOfTheStackSymbol) {
	addStackSymbol(bottomOfTheStackSymbol);
}

void BottomOfTheStackSymbolPushdownStoreAlphabet::setBottomOfTheStackSymbol(const alphabet::Symbol& start) {
	if (stackAlphabet.find(start) == stackAlphabet.end()) {
		throw AutomatonException("Stack symbol \"" + (std::string) start + "\" doesn't exist.");
	}
	
	bottomOfTheStackSymbol = start;
}

const alphabet::Symbol& BottomOfTheStackSymbolPushdownStoreAlphabet::getBottomOfTheStackSymbol() const {
	return bottomOfTheStackSymbol;
}

} /* namespace automaton */
