/*
 * SingleInitialSymbolPushdownStore.cpp
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "SingleInitialSymbolPushdownStoreAlphabet.h"
#include "../AutomatonException.h"
#include <algorithm>

namespace automaton {

SingleInitialSymbolPushdownStoreAlphabet::SingleInitialSymbolPushdownStoreAlphabet(const alphabet::Symbol& initialSymbol) : initialSymbol(initialSymbol) {
	addStackSymbol(initialSymbol);
}

void SingleInitialSymbolPushdownStoreAlphabet::setInitialSymbol(const alphabet::Symbol& start) {
	if (stackAlphabet.find(start) == stackAlphabet.end()) {
		throw AutomatonException("Stack symbol \"" + (std::string) start + "\" doesn't exist.");
	}
	
	initialSymbol = start;
}

const alphabet::Symbol& SingleInitialSymbolPushdownStoreAlphabet::getInitialSymbol() const {
	return initialSymbol;
}

} /* namespace automaton */
