/*
 * Set.cpp
 *
 * Created on: Apr 1, 2013
 * Author: Jan Travnicek
 */

#include "ObjectsSet.h"
#include "../std/set.hpp"

#include <cstdlib>
#include <iostream>
#include <sstream>

namespace container {

ContainerBase* ObjectsSet::clone() const {
	return new ObjectsSet(*this);
}

ContainerBase* ObjectsSet::plunder() && {
	return new ObjectsSet(std::move(*this));
}

bool ObjectsSet::operator==(const ObjectBase& other) const {
	return other == *this;
}

bool ObjectsSet::operator<(const ObjectBase& other) const {
	return other > *this;
}

bool ObjectsSet::operator>(const ObjectBase& other) const {
	return other < *this;
}

bool ObjectsSet::operator==(const ObjectsSet& other) const {
	return static_cast<const std::set<alib::Object>>(*this) == static_cast<const std::set<alib::Object>>(other);
}

bool ObjectsSet::operator<(const ObjectsSet& other) const {
	return static_cast<const std::set<alib::Object>>(*this) < static_cast<const std::set<alib::Object>>(other);
}

void ObjectsSet::operator>>(std::ostream& os) const {
	os << *this;
}

ObjectsSet::operator std::string() const {
	std::stringstream ss;
	ss << *this;
	return std::move(ss).str();
}

} /* namespace container */
