/*
 * ExceptionFromXMLParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef EXCEPTION_FROM_XML_PARSER_H_
#define EXCEPTION_FROM_XML_PARSER_H_

#include <list>
#include <set>
#include "../sax/FromXMLParserHelper.h"
#include "ExceptionFeatures.h"
#include "AlibException.h"

namespace alib {

template<typename T>
struct api;

} /* namespace alib */

namespace exception {

/**
 * Parser used to get String from XML parsed into list of tokens.
 */
class ExceptionFromXMLParser : public sax::FromXMLParserHelper {
	AlibException parseException(std::list<sax::Token>& input) const;
	AlibException parseException(std::list<sax::Token>& input, const std::set<FEATURES>& features) const;

public:
	bool first(std::list<sax::Token>& input) const;

	template<typename T> friend class alib::api;
};

} /* namespace exception */

#endif /* EXCEPTION_FROM_XML_PARSER_H_ */
