/*
 * GrammarBase.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef GRAMMAR_BASE_H_
#define GRAMMAR_BASE_H_

#include "../common/base.hpp"
#include "../object/ObjectBase.h"

namespace grammar {

typedef std::acceptor_base<
			grammar::UnknownGrammar, grammar::LeftLG, grammar::LeftRG, grammar::RightLG, grammar::RightRG, grammar::LG, grammar::CFG, grammar::EpsilonFreeCFG, grammar::CNF, grammar::GNF, grammar::CSG, grammar::NonContractingGrammar, grammar::ContextPreservingUnrestrictedGrammar, grammar::UnrestrictedGrammar
	> VisitableGrammarBase;

/**
 * Abstract base class for all grammars.
 */
class GrammarBase : public alib::ObjectBase, public VisitableGrammarBase {
public:
	using VisitableGrammarBase::Accept;
	using alib::VisitableObjectBase::Accept;

	virtual GrammarBase* clone() const = 0;
	virtual GrammarBase* plunder() && = 0;

};

} /* namespace grammar */

#endif /* GRAMMAR_BASE_H_ */

