/*
 * LabelToStringComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef LABEL_TO_STRING_COMPOSER_H_
#define LABEL_TO_STRING_COMPOSER_H_

#include <sstream>
#include "Label.h"
#include "../sax/Token.h"

namespace label {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class LabelToStringComposer : public VisitableLabelBase::visitor_type {
	void Visit(void*, const PrimitiveLabel& label);
	void Visit(void*, const HexavigesimalLabel& label);
	void Visit(void*, const ObjectLabel& label);
	void Visit(void*, const LabelSetLabel& label);
	void Visit(void*, const LabelPairLabel& label);
public:
	/**
	 * Prints text representation of Label to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	std::string compose(const Label& string);
};

} /* namespace label */

#endif /* LABEL_TO_STRING_COMPOSER_H_ */
