/*
 * NextPrimitive.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "NextPrimitive.h"
#include "Integer.h"
#include "String.h"
#include "Character.h"
#include "../std/itos.h"

namespace primitive {

void NextPrimitive::Visit(void* userData, const Integer& primitive) {
	Primitive* &out = *((Primitive**) userData);

	out = new Primitive(Integer(primitive.getData() + 1));
}

void NextPrimitive::Visit(void* userData, const Character& primitive) {
	Primitive* &out = *((Primitive**) userData);

	out = new Primitive(Character(primitive.getData() + 1));
}

void NextPrimitive::Visit(void* userData, const String& primitive) {
	Primitive* &out = *((Primitive**) userData);

	out = new Primitive(String(primitive.getData() + '\''));
}

Primitive NextPrimitive::nextPrimitive(const Primitive& primitive) {
	Primitive* out;
	primitive.getData().Accept((void*) &out, *this);

	Primitive nextPrimitive(std::move(*out));
	delete out;
	return std::move(nextPrimitive);
}

} /* namespace primitive */
