/*
 * PrimitiveFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef PRIMITIVE_FROM_STRING_PARSER_H_
#define PRIMITIVE_FROM_STRING_PARSER_H_

#include "Primitive.h"
#include "PrimitiveFeatures.h"
#include <set>
#include "../FromStringParser.hpp"

#include "PrimitiveFromStringLexer.h"

namespace label {

class LabelFromStringParser;

} /* namespace label */

namespace string {

class StringFromStringParser;

} /* namespace string */

namespace primitive {

class PrimitiveFromStringParser : public alib::FromStringParser<Primitive, FEATURES> {
	PrimitiveFromStringLexer m_Lexer;
	virtual Primitive parse(const std::set<FEATURES>&);
	virtual Primitive parse();

	bool next();
	virtual bool last();
public:
	virtual bool first();
	PrimitiveFromStringParser(std::istream&);
	friend class label::LabelFromStringParser;
	friend class string::StringFromStringParser;
};

} /* namespace primitive */

#endif /* PRIMITIVE_FROM_STRING_PARSER_H_ */
