/*
 * PrimitiveToStringComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef PRIMITIVE_TO_STRING_COMPOSER_H_
#define PRIMITIVE_TO_STRING_COMPOSER_H_

#include <sstream>
#include "Primitive.h"
#include "../sax/Token.h"

namespace primitive {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class PrimitiveToStringComposer : public VisitablePrimitiveBase::visitor_type {
	void Visit(void*, const Integer& primitive);
	void Visit(void*, const String& primitive);
	void Visit(void*, const Character& primitive);
public:
	/**
	 * Prints text representation of Primitive to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	std::string compose(const Primitive& string);
};

} /* namespace primitive */

#endif /* PRIMITIVE_TO_STRING_COMPOSER_H_ */
