/*
 * RegExpAlphabetGetter.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "RegExpAlphabetGetter.h"

namespace regexp {

void RegExpAlphabetGetter::Visit(void* userData, const UnboundedRegExp& regexp) const {
	const std::set<alphabet::Symbol>* &res = *((const std::set<alphabet::Symbol>**) userData);
	res = &regexp.getAlphabet();
}

void RegExpAlphabetGetter::Visit(void* userData, const FormalRegExp& regexp) const {
	const std::set<alphabet::Symbol>* &res = *((const std::set<alphabet::Symbol>**) userData);
	res = &regexp.getAlphabet();
}

const std::set<alphabet::Symbol>& RegExpAlphabetGetter::getAlphabet(const RegExp& regexp) const {
	const std::set<alphabet::Symbol>* res;
	regexp.getData().Accept((void*) &res, *this);
	return *res;
}

const RegExpAlphabetGetter RegExpAlphabetGetter::REG_EXP_ALPHABET_GETTER;

} /* namespace regexp */
