/*
 * ComposerException.h
 *
 *  Created on: Apr 16, 2013
 *      Author: Jan Travnicek
 */

#ifndef COMPOSER_EXCEPTION_H_
#define COMPOSER_EXCEPTION_H_

#include "../exception/AlibException.h"
#include "Token.h"

namespace sax {

/**
 * Exception thrown by XML parser when is expected different tag than the one which is read.
 */
class ComposerException: public exception::AlibException {
protected:
	Token expected;
	Token read;
public:
	ComposerException(const Token& expected, const Token& read);
	~ComposerException() noexcept;
};

} /* namespace sax */

#endif /* COMPOSER_EXCEPTION_H_ */

