#ifndef __SET_HPP_
#define __SET_HPP_

#include <set>

namespace std {

template< class T >
std::ostream& operator<<(std::ostream& out, const std::set<T>& list);

}

#include "map.hpp"
#include "pair.hpp"
#include "list.hpp"
#include "tuple.hpp"
#include "vector.hpp"
#include <iostream>

namespace std {

template< class T >
std::ostream& operator<<(std::ostream& out, const std::set<T>& list) {
	out << "{";

	bool first = true;
	for(const T& item : list) {
		if(!first) out << ", ";
		first = false;
		out << item;
	}

	out << "}";
	return out;
}

template<class T>
bool empty_intersection(const set<T>& x, const set<T>& y) {
	auto i = x.begin();
	auto j = y.begin();
	while (i != x.end() && j != y.end()) {
		if (*i == *j)
			return false;
		else if (*i < *j)
			++i;
		else
			++j;
	}
	return true;
}

} /* namespace std */

#endif /* __SET_HPP_ */

